//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www.kamami.com
// PROJECT  : 7SEGMENT
// BOARD    : ZL5PIC (with PIC16F884 in socket U1)
// COMPILER : PICC Lite 9.60
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple 7-segment LED display demonstration.
//
//    Settings and connections on ZL5PIC:
//        A (7SEG/con14) - RD0 (con18)
//        B (7SEG/con14) - RD1 (con18)
//        C (7SEG/con14) - RD2 (con18)
//        D (7SEG/con14) - RD3 (con18)
//        E (7SEG/con14) - RD4 (con18)
//        F (7SEG/con14) - RD5 (con18)
//        G (7SEG/con14) - RD6 (con18)
//        . (7SEG/con14) - RD7 (con18)
//
//        0 (7SEG/con14) - RC0 (con17)
//        1 (7SEG/con14) - RC1 (con17)
//        2 (7SEG/con14) - RC2 (con17)
//        3 (7SEG/con14) - RC3 (con17)
//
//******************************************************************************
#include <htc.h>

__CONFIG(WDTDIS & XT & UNPROTECT);

volatile unsigned char DisplayCounter;
volatile unsigned char Digit0, Digit1, Digit2, Digit3;
// Digits patterns
const unsigned char Digits[]= {192, 249, 164, 176, 153, 146, 130, 248, 128, 144, 136, 131, 198, 161, 134, 142};
//-------------------------------------
//
//-------------------------------------
void main(void)
{
TRISD = 0;
TRISC = 0;
PORTC = 0x0F;
T0CS = 0;
PS2 = 1;
PS1 = 0;
PS0 = 0;
PSA = 0;
T0IE = 1;		
GIE = 1;

DisplayCounter = 0;

Digit0=Digits[0];  // write digit '0' pattern to Ditig0
Digit1=Digits[1];  // write digit '1' pattern to Ditig1
Digit2=Digits[2];  // write digit '2' pattern to Ditig2
Digit3=Digits[3];  // write digit '3' pattern to Ditig3

while(1);
}
//-------------------------------------
// interrupt handler
//-------------------------------------
void interrupt isr(void)
{
T0IF = 0;
DisplayCounter++;
switch(DisplayCounter){
case 1: 
  PORTC |= (1 << 3); 	 // DS3 off
  PORTD = Digit0; 		 // write digit to port
  PORTC &= ~(1 << 0);    // DS0 on
  break;
case 2: 
  PORTC |= (1 << 0);	 // DS0 off
  PORTD = Digit1;		 // write digit to port
  PORTC &= ~(1 << 1);    // DS1 on
  break;
case 3:
  PORTC |= (1 << 1);	 // DS1 off
  PORTD = Digit2;		 // write digit to port
  PORTC &= ~(1 << 2);    // DS2 on
break;
case 4: 
  PORTC |= (1 << 2);	 // DS2 off
  PORTD = Digit3;		 // write digit to port
  PORTC &= ~(1 << 3);    // DS3 on
  DisplayCounter=0;
break;
}
}
//-------------------------------------
// End of file
//-------------------------------------