//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : BUZZER
// BOARD    : ZL5PIC (with PIC16F884 in socket U1)
// COMPILER : PICC Lite 9.60
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple sound generating.
//
//    Settings and connections on ZL5PIC:
//        RC0 (con17) - SPK (con7)
//
//******************************************************************************
#include <htc.h>

__CONFIG(WDTDIS & XT & UNPROTECT);


//-------------------------------------
// Sound function
//-------------------------------------
void Sound(int duration, int pulses)
{
volatile int i;
while(duration--)
  {
  for(i = pulses ; i > 0; i--);
  PORTC ^= 1 ;
  }
}
//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
volatile unsigned int i;
TRISC = 0; // Config port

// Infinite loop
do{
  Sound(500,40);			    // play sound
  for(i = 0; i < 0x7FFF; i++);	// wait
}while(1);
return 0;
}
//-------------------------------------
// End of file
//-------------------------------------
