//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : CHAR LCD
// BOARD    : ZL5PIC (with PIC16F884 in socket U1)
// COMPILER : PICC Lite 9.60
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Using LCD character display (HD44780 compatible) in 4-bit mode.
//
//    Settings and connections on ZL5PIC:
//        JP4 (DISPLAY) - 2-3 (=CHAR)
//
//        D4 (LCD_CHAR/con13) - RD4 (con18)
//        D5 (LCD_CHAR/con13) - RD5 (con18)
//        D6 (LCD_CHAR/con13) - RD6 (con18)
//        D7 (LCD_CHAR/con13) - RD7 (con18)
//        E  (LCD_CHAR/con13) - RD2 (con18)
//        RS (LCD_CHAR/con13) - RD0 (con18)
//        RW (LCD_CHAR/con13) - GND (con18)
//
//
//******************************************************************************
#include <htc.h>
#include "HD44780.h"

__CONFIG(WDTDIS & XT & UNPROTECT);

int main(void)
{
int i, temp;

LCD_Initialize();
LCD_GoTo(0,0);
LCD_WriteText(" -- ZL5PIC -- ZL5PIC --");
LCD_GoTo(0,1);
LCD_WriteText(" Kamami Development Board");

do{
for(temp = 0; temp < 10; temp++) // shift the text to the left
  {
  LCD_ShiftLeft();
  for(i = 0; i < 0x7FFF; i++);
  }
for(temp = 0; temp < 10; temp++) // shift the text to the right 
  {
  LCD_ShiftRight();
  for(i = 0; i < 0x7FFF; i++);
  }
}while(1);
return 0;	
}	