//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : CHAR LCD
// BOARD    : ZL5PIC (with PIC16F884 in socket U1)
// COMPILER : PICC Lite 9.60
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Using LCD graphic display (KS0108 compatible)
//
//    Settings and connections on ZL5PIC:
//        JP4 (DISPLAY) - 1-2 (=GRAPH)
//
//        D0 (LCD_GRAPH/con12) - RD0 (con15)
//        D1 (LCD_GRAPH/con12) - RD1 (con15)
//        D2 (LCD_GRAPH/con12) - RD2 (con15)
//        D3 (LCD_GRAPH/con12) - RD3 (con15)
//        D4 (LCD_GRAPH/con12) - RD4 (con15)
//        D5 (LCD_GRAPH/con12) - RD5 (con15)
//        D6 (LCD_GRAPH/con12) - RD6 (con15)
//        D7 (LCD_GRAPH/con12) - RD7 (con15)
//
//        RS (LCD_GRAPH/con12) - RC0 (con16)
//        RW (LCD_GRAPH/con12) - RC1 (con16)
//        E  (LCD_GRAPH/con12) - RC2 (con16)
//        CS1(LCD_GRAPH/con12) - RC4 (con16)
//        CS2(LCD_GRAPH/con12) - RC5 (con16)
//
//******************************************************************************
#include <htc.h>
#include "KS0108.h"
#include "kamami.h"

__CONFIG(WDTDIS & XT & UNPROTECT & PWRTEN);

int main(void)
{
volatile unsigned int i,j;

GLCD_Initialize();  							// LCD initialization

do{
GLCD_ClearScreen(); 							// clear screen

GLCD_WriteStringXY("   K A M A M I",12,0);		//
GLCD_WriteStringXY("development board",12,1);	// display text
GLCD_WriteStringXY("  -- ZL5PIC --  ",12,3);	//
GLCD_WriteStringXY(" www.kamami.com ",12,4);	//

for(j = 0; j < 5; j++)							//
  for(i = 0; i < 0xFFFF; i++);					// wait

GLCD_Bitmap((const char *)kamami, 0, 0, 128 , 64);	// display picture

for(j = 0; j < 5; j++)							//	
  for(i = 0; i < 0xFFFF; i++);					// wait	


  }while(1);
return 0;
}
