//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : RC5
// BOARD    : ZL5PIC (with PIC16F884 in socket U1)
// COMPILER : PICC Lite 9.60
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple infrared RC5 code receiver
//
//    Settings and connections on ZL5PIC:
//        IR (con7) - RB0 (con16)
//
//      if RS232 cable connected:
//        RxD (con7) - RC7 (con17)
//        TxD (con7) - RC6 (con17)
//
//      if UART2USB converter (ZL1USB_A or ZL4USB) connected:
//        RxU (con7) - RC7 (con17)
//        TxU (con7) - RC6 (con17)
//
//******************************************************************************
#include <htc.h>
#include "EUSART.h"
#include "RC5.h"

__CONFIG(WDTDIS & XT & UNPROTECT);

extern volatile unsigned char Cmd, CmdN, Adr, AdrN;

//-------------------------------------
// main program
//-------------------------------------
int main(void)
{
char str [5];
char RC5Address=0, RC5Command=0;

USART_Init();

USART_PutString("*************************\r");
USART_PutString("**    ZL5PIC IR RC5    **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");

USART_PutString("Waiting for RC5...\r");

RC5_Init();

do{
  GetRC5(&RC5Address, &RC5Command);
  USART_PutString("Address (hex): ");
  USART_PutString(Hex(RC5Address, str));
  USART_PutString(" Command (hex): ");
  USART_PutString(Hex(RC5Command, str));
  USART_PutChar('\r');
}while(1);
return 0;
}

