//-----------------------------------------------
//
//-----------------------------------------------
#include <htc.h>

#define CYCLESPERUS 2

#define PRESCALE	1
#define TICKSPERUS(x) ((x*CYCLESPERUS)/PRESCALE)
#define TIMERVALUE(x) (65535-(TICKSPERUS(x)))

#define RC5IN RB0

volatile unsigned char Cmd, CmdN, Adr, AdrN;
volatile unsigned char RC5Counter, RC5Status;

void extint(void);
void timerint(void);

//-----------------------------------------------
//
//-----------------------------------------------
static void interrupt isr(void)
{
	if(TMR1IF)
	{
	TMR1H = (char) (TIMERVALUE(870) >> 8);
	TMR1L = (char) TIMERVALUE(870);	
	TMR1IF = 0;
	timerint();
	}
	
	if(INTF & INTE)
	{
	TMR1H = (char) (TIMERVALUE(442) >> 8);
	TMR1L = (char) TIMERVALUE(442);
	
	TMR1CS = 0;
	TMR1ON = 1;
	TMR1IE = 1;
	
	INTF = 0;
	INTE = 0;
	
	Cmd=CmdN=Adr=AdrN = 0;
    RC5Counter = 0;
	RC5Status = 0;	
	}
}
//-----------------------------------------------
//
//-----------------------------------------------
void timerint(void)
{
	RC5Counter++;

	if(RC5Counter == 1)
	  return;
	
	if((RC5Counter < 28)&&(RC5Counter < 16))
	  {
	  if((RC5Counter&1)==0)
	    {
	    Adr <<= 1;
	    if(RC5IN)
	      Adr |= 1;
	    }
	  else
	    {
	    AdrN <<= 1;
	    if(!RC5IN)
	      AdrN |= 1;
	    }
	  }
	else
	if((RC5Counter < 28)&&(RC5Counter >= 16))
	  {
	  if((RC5Counter&1)==0)
	    {
	    Cmd <<= 1;
	    if(RC5IN)
	      Cmd |= 1;
	    }
	  else
	    {
	    CmdN <<= 1;
	    if(!RC5IN)
	      CmdN |= 1;
	    }
	  }
	else
	if(RC5Counter == 28)
	  {
  
  	  TMR1ON = 0;
	  INTF = 0;
	  INTE = 1;

	  RC5Counter = 0;
	  if(Cmd != CmdN)
	    return;
	  if(Adr != AdrN)
	    return;
	  Adr &= 0x1F;
	  Cmd &= 0x3F;
	
	  RC5Status |= 1;
	
	  }		
}
//-----------------------------------------------
//
//-----------------------------------------------
void GetRC5(char * Address, char * Command)
{
while((RC5Status & 1)==0);
RC5Status = 0;
*Address = Adr;
*Command = Cmd;
}
//-----------------------------------------------
//
//-----------------------------------------------
void RC5_Init(void)
{
Cmd=CmdN=Adr=AdrN = 0;
RC5Counter = 0;
RC5Status = 0;

ANSELH = 0;
GIE = 1;
INTE = 1;
INTEDG = 0;
PEIE = 1;
}
//-----------------------------------------------
//
//-----------------------------------------------
