//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
#include <htc.h>

#define I2C_DR  PORTC
#define I2C_DDR TRISC


#define I2C_SDA (1 << 4)
#define I2C_SCL (1 << 3)
//-------------------------------------
// Delay routine
//-------------------------------------
void TWI_Delay(void)
{
asm("nop");
asm("nop");
//_nop_();
//_nop_();
//_nop_();
//_nop_();
//_nop_();
//_nop_();
}
//-------------------------------------
// Initialize TWI
//-------------------------------------
void TWI_Init(void)
{
I2C_DR  &= ~(I2C_SDA | I2C_SCL);
I2C_DDR |= (I2C_SDA | I2C_SCL);
}
//-------------------------------------
// Generate START signal
//-------------------------------------
void TWI_Start(void)
{
I2C_DR  &= ~(I2C_SDA | I2C_SCL);
I2C_DDR |= (I2C_SDA | I2C_SCL);
TWI_Delay();
I2C_DDR &= ~I2C_SDA;
TWI_Delay();
I2C_DDR &= ~I2C_SCL;
TWI_Delay();
}
//-------------------------------------
// Generate STOP signal
//-------------------------------------
void TWI_Stop(void)
{
TWI_Delay();
I2C_DDR |= I2C_SCL;
TWI_Delay();
I2C_DDR |= I2C_SDA;
}
//-------------------------------------
// Write byte to slave
//-------------------------------------
unsigned char TWI_Write(unsigned char val)
{
char cnt = 8;
unsigned char ack=0;
I2C_DDR &= ~(I2C_SDA | I2C_SCL);
do{
    if(val & 0x80)
        I2C_DDR |= I2C_SDA;        
    else
        I2C_DDR &= ~I2C_SDA;
    TWI_Delay();    
    I2C_DDR |= I2C_SCL;
    TWI_Delay();
    I2C_DDR &= ~I2C_SCL;
    val <<= 1;
    cnt --;
}while(cnt);

I2C_DDR |= I2C_SDA;
TWI_Delay();
I2C_DDR |= I2C_SCL;
TWI_Delay();
if(I2C_DR & I2C_SDA)
    ack = 1;
else
    ack = 0;
 
I2C_DDR &= ~I2C_SCL;   
I2C_DDR &= ~I2C_SDA;
TWI_Delay();
return ack;
}
//-------------------------------------
// Read byte from slave
//-------------------------------------
unsigned char TWI_Read(unsigned char ack)
{
unsigned char cnt = 8;
unsigned char val = 0;

I2C_DDR &= ~(I2C_SDA | I2C_SCL);

I2C_DDR = I2C_SDA;
do{
    val <<= 1;
    TWI_Delay();
    I2C_DDR |= I2C_SCL;
    TWI_Delay();
    if(I2C_DR & I2C_SDA)
        val |= 1;
    I2C_DDR &= ~I2C_SCL;
    cnt --;
}while(cnt);

if(ack)
   I2C_DDR |= I2C_SDA;
else
   I2C_DDR &= ~I2C_SDA; 
I2C_DDR |= I2C_SCL;
TWI_Delay();
I2C_DDR &= ~I2C_SCL;
I2C_DDR &= ~I2C_SDA;
return val;
}
//-------------------------------------
// End of file
//-------------------------------------