//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : RTC
// BOARD    : ZL5PIC (with PIC16F884 in socket U1)
// COMPILER : PICC Lite 9.60
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple I2C communication demo.
//    Read time from RTC (U6 - M41T00)
//    and transmit it to PC via UART.
//
//    Settings and connections on ZL5PIC:
//        SCL (U6 RTC/con7) - RC3 (con17)
//        SDA (U6 RTC/con7) - RC4 (con17)
//
//      if RS232 cable connected:
//        RxD (con7) - RC7 (con17)
//        TxD (con7) - RC6 (con17)
//
//      if UART2USB converter (ZL1USB_A or ZL4USB) connected:
//        RxU (con7) - RC7 (con17)
//        TxU (con7) - RC6 (con17)
//
//******************************************************************************
#include <htc.h>
#include "EUSART.h"
#include "TWI.h"

__CONFIG(WDTDIS & XT & UNPROTECT & PWRTEN);

//-------------------------------------
// main program
//-------------------------------------
void main(void)
{
char B1;
volatile unsigned int i;

TWI_Init();
USART_Init();

USART_PutString("\r");
USART_PutString("*************************\r");
USART_PutString("**     ZL5PIC   RTC    **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");

do{
USART_PutString("M41T00\r");

TWI_Start();                        // start transmission
TWI_Write(0xD0);                    // write addres of M41T00
TWI_Write(0x02);                    // select hours register
TWI_Start();                        // repeated start
TWI_Write(0xD1);                    // write address for reading data
B1 = TWI_Read(NACK);                // read hours register
TWI_Stop();                         // stop transmission    

USART_PutChar(((B1>>4)&3)+'0');     // convert hours to ASCII char
USART_PutChar((B1&15)+'0');         // convert hours to ASCII char
USART_PutChar(':');                         

TWI_Start();                        // start transmission  
TWI_Write(0xD0);                    // write addres of M41T00
TWI_Write(0x01);                    // select minutes register  
TWI_Start();                        // repeated start
TWI_Write(0xD1);                    // write address for reading data
B1 = TWI_Read(NACK);                // read minutes register
TWI_Stop();                         // stop transmission

USART_PutChar(((B1>>4)&7)+'0');     // convert minutes to ASCII char
USART_PutChar((B1&15)+'0');         // convert minutes to ASCII char
USART_PutChar(':');

TWI_Start();                        // start transmission
TWI_Write(0xD0);                    // write addres of M41T00
TWI_Write(0x00);                    // select seconds register
TWI_Start();                        // repeated start         
TWI_Write(0xD1);                    // write address for reading data
B1 = TWI_Read(NACK);                // read minutes register
TWI_Stop();                         // stop transmission

USART_PutChar(((B1>>4)&7)+'0');     // convert seconds to ASCII char
USART_PutChar((B1&15)+'0');         // convert seconds to ASCII char
USART_PutChar('\r');

USART_PutString("------------------------------------------\r");
for(i = 0; i < 0xFFFF; i++);

}while(1);
}
//-------------------------------------
// End of file
//-------------------------------------
