//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : TEMP MCP9801
// BOARD    : ZL5PIC (with PIC16F884 in socket U1)
// COMPILER : PICC Lite 9.60
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple I2C communication demo.
//    Read temperature register from MCP9801 (U4)
//    and transmit it to PC via UART.
//
//    Settings and connections on ZL5PIC:
//        SCK (U4 TEM/con8) - RC3 (con17)
//        SDA (U4 TEM/con8) - RC4 (con17)
//
//      if RS232 cable connected:
//        RxD (con7) - RC7 (con17)
//        TxD (con7) - RC6 (con17)
//
//      if UART2USB converter (ZL1USB_A or ZL4USB) connected:
//        RxU (con7) - RC7 (con17)
//        TxU (con7) - RC6 (con17)
//
//******************************************************************************
#include <htc.h>
#include "TWI.h"
#include "EUSART.h"
#include <stdlib.h>

__CONFIG(WDTDIS & XT & UNPROTECT & PWRTEN);

void main(void)
{
char A1 = 0,A2 = 0;
char str[5];
volatile int i = 0;
	
TWI_Init();
USART_Init();


USART_PutString("\r");
USART_PutString("*************************\r");
USART_PutString("**   ZL5PIC  MCP9801   **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");

do{
	TWI_Start();
	TWI_Write(0x92);
	TWI_Write(0x00);
	TWI_Start();
	TWI_Write(0x93);
	A1 = TWI_Read(ACK);
	A2 = TWI_Read(NACK);
	TWI_Stop();
	
	USART_PutString("MCP9801 output (hex): ");
	USART_PutString(Hex(A1,str)); // convert to hex and send 
	USART_PutString(Hex(A2,str)); // convert to hex and send
	USART_PutChar('\r');
	USART_PutString("MCP9801 temperature: ");
	USART_PutString(itoa(str, A1, 10)); // convert to dec and send
	USART_PutChar('\r');
	for(i = 0; i < 0xFFFF; i++);
}while(1);
	
}	