//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
#include <htc.h>
#include "hd44780.h"

//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------

#define LCD_RS_DIR		TRISD0
#define LCD_RS_PORT 	
#define LCD_RS			RD0


#define LCD_EN_DIR		TRISD2
#define LCD_EN_PORT		PORTD
#define LCD_EN			RD2


#define LCD_DB4_DIR		TRISD4
#define LCD_DB4_PORT	PORTD
#define LCD_DB4			RD4


#define LCD_DB5_DIR		TRISD5
#define LCD_DB5_PORT	PORTD
#define LCD_DB5			RD5


#define LCD_DB6_DIR		TRISD6
#define LCD_DB6_PORT	PORTD
#define LCD_DB6			RD6


#define LCD_DB7_DIR		TRISD7
#define LCD_DB7_PORT	PORTD
#define LCD_DB7			RD7

//--------------------------------------------------------------------------------------------------
// Delay function (10us for FCPU = 8MHz)
//--------------------------------------------------------------------------------------------------
void wait_10us(void)
{
volatile unsigned char i;
//_nop_();
for(i = 0; i < 10; i++);
}
//--------------------------------------------------------------------------------------------------
// delay*10us for FCPU = 8MHz
//--------------------------------------------------------------------------------------------------
void LCD_Delay(unsigned char delay)
{
for( ;delay > 0; delay--)
  wait_10us();
}
//-------------------------------------
// Write half byte
//-------------------------------------
void _LCD_OutNibble(unsigned char nibbleToWrite)
{
if(nibbleToWrite & 0x01)
	LCD_DB4 = 1;
else
	LCD_DB4 = 0;

if(nibbleToWrite & 0x02)
    LCD_DB5 = 1;
else
	LCD_DB5 = 0;

if(nibbleToWrite & 0x04)
	LCD_DB6 = 1;
else
	LCD_DB6 = 0;

if(nibbleToWrite & 0x08)
	LCD_DB7 = 1;
else
	LCD_DB7 = 0;
}
//-------------------------------------
// Write byte
//-------------------------------------
void _LCD_Write(unsigned char dataToWrite)
{

_LCD_OutNibble(dataToWrite >> 4);
LCD_EN = 1;
LCD_EN = 0;
_LCD_OutNibble(dataToWrite);
LCD_EN = 1;
LCD_EN = 0;
LCD_Delay(5);
}
//-------------------------------------
// Write to command register
//-------------------------------------
void LCD_WriteCommand(unsigned char commandToWrite)
{
LCD_RS = 0;
_LCD_Write(commandToWrite);
}
//-------------------------------------
// Write to data register
//-------------------------------------
void LCD_WriteData(unsigned char dataToWrite)
{
LCD_RS = 1;
_LCD_Write(dataToWrite);
}
//-------------------------------------
// Write text
//-------------------------------------
void LCD_WriteText(char * text)
{
while(*text){
  if(*text == '\r')
      return;
  LCD_WriteData(*text++);
}
}
//-------------------------------------
// Set display coordinates
//-------------------------------------
void LCD_GoTo(unsigned char x, unsigned char y)
{
LCD_WriteCommand(HD44780_DDRAM_SET | (x + (0x40 * y)));
}
//-------------------------------------
// Clear display
//-------------------------------------
void LCD_Clear(void)
{
LCD_WriteCommand(HD44780_CLEAR);
LCD_Delay(200);
}
//-------------------------------------
// Set home position
//-------------------------------------
void LCD_Home(void)
{
LCD_WriteCommand(HD44780_HOME);
LCD_Delay(200);
}
//-------------------------------------
// Shift display left
//-------------------------------------
void LCD_ShiftLeft(void)
{
LCD_WriteCommand(HD44780_DISPLAY_CURSOR_SHIFT | HD44780_SHIFT_LEFT | HD44780_SHIFT_DISPLAY);
}
//-------------------------------------
// Shift display right
//-------------------------------------
void LCD_ShiftRight(void)
{
LCD_WriteCommand(HD44780_DISPLAY_CURSOR_SHIFT | HD44780_SHIFT_RIGHT | HD44780_SHIFT_DISPLAY);
}
//-------------------------------------
// Display initialization
//-------------------------------------
void LCD_Initialize(void)
{
volatile unsigned char i;
TRISD = 0x00;
PORTD = 0xFF;

LCD_DB4_DIR = 0; 
LCD_DB5_DIR = 0; 
LCD_DB6_DIR = 0; 
LCD_DB7_DIR = 0; 
LCD_EN_DIR  = 0;   
LCD_RS_DIR 	= 0;

LCD_RS = 0; 
LCD_EN = 0;  

for(i = 0 ; i < 10; i++)
  LCD_Delay(10);

for(i = 0; i < 3; i++)
  {
  _LCD_OutNibble(0x03); 
  LCD_EN = 1; 
  LCD_EN = 0; 
  LCD_Delay(250);
  LCD_Delay(250);  
  }


_LCD_OutNibble(0x02); 
LCD_EN = 1; 
LCD_EN = 0; 

LCD_Delay(100);
LCD_WriteCommand(HD44780_FUNCTION_SET | HD44780_FONT5x7 | HD44780_TWO_LINE | HD44780_4_BIT); 
LCD_WriteCommand(HD44780_DISPLAY_ONOFF | HD44780_DISPLAY_OFF); 
LCD_WriteCommand(HD44780_CLEAR); 
LCD_Delay(200);
LCD_WriteCommand(HD44780_ENTRY_MODE | HD44780_EM_SHIFT_CURSOR | HD44780_EM_INCREMENT);
LCD_WriteCommand(HD44780_DISPLAY_ONOFF | HD44780_DISPLAY_ON | HD44780_CURSOR_OFF | HD44780_CURSOR_NOBLINK);
}
//-------------------------------------
// End of file
//-------------------------------------
