//***************** (c) 2008 BTC Korporacja ***********************************
//                     http://www kamami.com
// PROJECT  : UART
// BOARD    : ZL5PIC (with PIC16F884 in socket U1)
// COMPILER : PICC Lite 9.60
//
//******************************************************************************
//
//    THE SOFTWARE INCLUDED IN THIS FILE IS FOR GUIDANCE ONLY.
//    BTC KORPORACJA SHALL NOT BE HELD LIABLE FOR ANY DIRECT, INDIRECT
//    OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING
//    FROM USE OF THIS SOFTWARE.
//
//******************************************************************************
//
// DESCRIPTION :
//    Simple UART communication demo.
//
//    Settings and connections on ZL5PIC:
//        JP4 (DISPLAY) - 2-3 (=CHAR)
//
//        D4 (LCD_CHAR/con13) - RD4 (con18)
//        D5 (LCD_CHAR/con13) - RD5 (con18)
//        D6 (LCD_CHAR/con13) - RD6 (con18)
//        D7 (LCD_CHAR/con13) - RD7 (con18)
//        E  (LCD_CHAR/con13) - RD2 (con18)
//        RS (LCD_CHAR/con13) - RD0 (con18)
//        RW (LCD_CHAR/con13) - GND (con18)
//
//      if RS232 cable connected:
//        RxD (con7) - RC7 (con17)
//        TxD (con7) - RC6 (con17)
//
//      if UART2USB converter (ZL1USB_A or ZL4USB) connected:
//        RxU (con7) - RC7 (con17)
//        TxU (con7) - RC6 (con17)
//
//******************************************************************************
#include <htc.h>
#include "HD44780.h"
#include "EUSART.h"

__CONFIG(WDTDIS & XT & UNPROTECT);


void main(void)
{
char Message[18];

USART_Init();

LCD_Initialize();
LCD_GoTo(0,0);
LCD_WriteText("ZL5PIC - EUSART");
LCD_GoTo(0,1);
LCD_WriteText(" www.kamami.com");

USART_PutChar('\r');
USART_PutString("*************************\r");
USART_PutString("**     ZL5PIC EUSART   **\r");
USART_PutString("**    www.kamami.com   **\r");
USART_PutString("*************************\r");

do{
  USART_PutString("->");USART_GetString(Message);
  USART_PutString("<-");USART_PutString(Message);
  LCD_Clear();
  LCD_GoTo(0,0);
  LCD_WriteText("Rx:");
  LCD_GoTo(0,1);
  LCD_WriteText(Message);
}while(1);
}	